/*   QNX --   */
#include <signal.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/inline.h>
#include <sys/proxy.h>
#include <sys/kernel.h>
#include <sys/irqinfo.h>
#include <sys/console.h>
#include <sys/con_msg.h>
#include <time.h>

#define LEFT_CTRL_ON	0x1D
#define LEFT_SHIFT_ON	0x2A
#define ST_RUS		1
#define ST_LAT		0

struct msg_keymap {
msg_t				type;
short unsigned		handle;
short unsigned		zero[2];
short int			nwords;
short unsigned		data[480];
};

struct msg_keymap USA,KOI,*ptr;

struct _console_setkbmap_reply reply;
char ch;
int ctrl;
pid_t hitkey;

#pragma off(check_stack);
pid_t far kbd_handler()
{
return(hitkey);
}
#pragma on(check_stack);


main(int argc,char *argv[])
{
int i,fd;
int state;
char strRUS[6]={'R',0x70,'U',0x70,'S',0x70 };
char strLAT[6]={'L',0x70,'A',0x70,'T',0x70 };
char *cptr;
struct _console_ctrl *cc;
struct sigevent ev;
struct itimerspec it;
timer_t id;
pid_t event,ptick;

if(argc!=3) { printf("rk-info: Usage: rk kbdfile1 kbdfile2\n"); exit(-1); }

if((fd=open(argv[1],O_RDONLY))==-1)
 { printf("rk-fatal: open(argv[1],O_RDONLY)==-1)\n"); exit(errno); }
lseek(fd,32,SEEK_SET); read(fd,&USA.data,960); close(fd);

if((fd=open(argv[2],O_RDONLY))==-1)
 { printf("rk-fatal: open(argv[2],O_RDONLY)==-1)\n"); exit(errno); }
lseek(fd,32,SEEK_SET); read(fd,&KOI.data,960); close(fd);

USA.type=KOI.type=_CONSOLE_SETKBMAP;
USA.zero[0]=USA.zero[1]=KOI.zero[0]=KOI.zero[1]=0;
USA.nwords=KOI.nwords=480;

if((hitkey=qnx_proxy_attach(0,0,0,-1))==-1 ||
   (ptick=qnx_proxy_attach(0,0,0,-1))==-1 )
 { printf("rk-fatal: qnx_proxy_attach()==-1)\n"); exit(errno); }

ctrl=0; state=ST_LAT; cptr=strLAT; ev.sigev_signo=-ptick;
it.it_value.tv_sec=1;
it.it_value.tv_nsec=0;
it.it_interval.tv_sec=1;
it.it_interval.tv_nsec=0;

if((id=timer_create(CLOCK_REALTIME,&ev))==-1)
 { printf("rk-fatal: qnx_timer_create()==-1)\n"); exit(errno); }

if(qnx_hint_attach(1,&kbd_handler,FP_SEG(&ch))==-1)
 { printf("rk-fatal: qnx_hint_attach()==-1)\n"); exit(errno); }

timer_settime(id,0,&it,NULL);

for(;;)
{
event=Receive(0,0,0);

if(event==hitkey)
{
 ch=inb(0x60);
 if(! ((ch==LEFT_CTRL_ON && ctrl==LEFT_SHIFT_ON) ||
       (ctrl==LEFT_CTRL_ON && ch==LEFT_SHIFT_ON)  ))
   { ctrl=ch; continue; }
 ctrl=ch;

 if(state==ST_LAT) { state=ST_RUS; cptr=strRUS; ptr=&KOI; }
 else		   { state=ST_LAT; cptr=strLAT; ptr=&USA; }
}

/*   */
if((fd=open("/dev/con1",O_RDWR))==-1) continue;
cc=console_open(fd,O_RDWR); close(fd);
if(cc==NULL) continue;

/*    */
USA.handle=KOI.handle=cc->handle;

if((i=console_active(cc,-1))!=-1 &&
   (event==ptick ||
    Send(cc->driver_pid,ptr,&reply,sizeof(struct msg_keymap),sizeof(reply))==0
   )
  )
  console_write(cc,i,160-6,cptr,6,NULL,NULL,NULL);

console_close(cc);

} /* end of for(;;) */

}
